<script setup lang="ts">
    import { graphql } from "./../gql/index";
    import { computed, ref, watch } from "vue";
    import { useQuery } from "@vue/apollo-composable";
    import { useRouter } from "vue-router";
    import useNavigationStore from "./../stores/navigation";
    import { DynamicRoutePaths } from "../plugins/router";

    const router = useRouter();
    const navigationStore = useNavigationStore();

    function selectEventId(id: string) {
        navigationStore.eventId = id;
        router.push({ name: DynamicRoutePaths.EventAndZirkelDetails }); // TODO move this out possibly
    }

    function selectZirkelId(id: string) {
        navigationStore.zirkelId = id;
        router.push({ name: DynamicRoutePaths.EventAndZirkelDetails }); // TODO move this out possibly
    }

    const expandedZirkelViewStorageKey = "expanded_zirkel_view_switch";
    const zirkelViewExpanded = ref((sessionStorage.getItem(expandedZirkelViewStorageKey) ?? "false") == "true");
    watch(zirkelViewExpanded, () => {
        sessionStorage.setItem(expandedZirkelViewStorageKey, zirkelViewExpanded.value ? "true" : "false");
    });

    // all events query
    const eventsQuery = graphql(`
        query EventsAndZirkelNames {
            allEvents {
                id
                name
                year
                startDate
                zirkel {
                    id
                    name
                }
            }
        }
    `);
    const { result: eventsResult } = useQuery(eventsQuery, null, {
        fetchPolicy: "cache-and-network",
    });
    interface Event {
        id: string;
        name: string;
        year: number;
        startDate: string;
        zirkel: { id: string; name: string }[];
    }
    const events = computed(() => {
        let ret = [] as Event[];
        (eventsResult.value?.allEvents! ?? []).forEach((event) => {
            let eve = {
                id: event.id,
                name: event.name,
                year: event.year,
                startDate: event.startDate,
            } as Event;

            eve.zirkel = structuredClone(event.zirkel ?? []).sort((a, b) => {
                return a.name.localeCompare(b.name);
            });

            ret.push(eve);
        });

        ret.sort((a, b) => {
            return b.startDate.localeCompare(a.startDate);
        });

        return ret;
    });
</script>

<template>
    <div class="pa-3">
        <h2 class="text-center">Events + Zirkel</h2>

        <v-card variant="tonal" class="my-2">
            <template v-slot:title>
                Liste der Veranstaltungen
                <div style="float: right">
                    <v-tooltip location="top">
                        <template v-slot:activator="{ props }">
                            <v-switch
                                inset
                                v-model="zirkelViewExpanded"
                                color="primary"
                                class="ml-1"
                                style="padding-inline-start: 0px"
                                hide-details
                                v-bind="props"
                            ></v-switch>
                        </template>
                        <span>Zirkel anzeigen</span>
                    </v-tooltip>
                </div>
            </template>
            <template v-slot:text>
                <v-table density="compact">
                    <thead>
                        <tr>
                            <th class="text-left">Veranstaltung</th>
                            <th class="text-left">Jahr</th>
                            <th class="text-left">Zirkel</th>
                            <th class="text-left"></th>
                        </tr>
                    </thead>
                    <tbody>
                        <template v-for="event in events" :key="event.id">
                            <tr>
                                <td>{{ event.name }}</td>
                                <td>{{ event.year }}</td>
                                <td>
                                    <span v-if="!zirkelViewExpanded">
                                        {{ event.zirkel.length }}
                                    </span>
                                </td>
                                <td>
                                    <v-btn size="small" @click="selectEventId(event.id)">
                                        <template v-slot:prepend>
                                            <span class="material-symbols-outlined"> search </span></template
                                        >
                                        Veranstaltung anzeigen
                                    </v-btn>
                                </td>
                            </tr>
                            <template v-if="zirkelViewExpanded">
                                <tr v-for="zirkel in event.zirkel" :key="zirkel.id">
                                    <td></td>
                                    <td></td>
                                    <td>{{ zirkel.name }}</td>
                                    <td>
                                        <v-btn size="small" @click="selectZirkelId(zirkel.id)">
                                            <template v-slot:prepend>
                                                <span class="material-symbols-outlined"> search </span></template
                                            >
                                            Zirkel anzeigen
                                        </v-btn>
                                    </td>
                                </tr>
                            </template>
                        </template>
                    </tbody>
                </v-table>
            </template>
        </v-card>
    </div>
</template>
